#!"\xampp\perl\bin\perl.exe"

#monitor.pl
my $ver="24.10.27";

#lib and path are set by startscript
use lib "C:/xampp/web-gui/data/cs_server/CGI";

# path to serverscript
$spath="C:/xampp/web-gui/data/cs_server";

#tmpfolder
$tpath="/xampp/web-gui/tmp";

use strict;
use utf8;

#use File::stat;
use Fcntl qw(:flock);                                        # filelocking

# auto-flush
$| = 1;

use vars qw(@f $client $ip $cmd $reply $t $tpath $wpath $dpath $spath $p_zfsmin $p_zpoolmin $last);

# is this windows?
my $dn = $^O;                                   # distribution from Perl ex MSWin32

my $perl="perl";                                # perl in path
if ($dn=~/mswin/i){
    $perl="c:/xampp/perl/bin/perl.exe";         # Windows
}

print "\ninitiate monitor service $ver\n";

# example for ps commands
#print `powershell.exe -command \"get-disk | select size\";`;

&my_deltmp;  # dell all tmp files on startup  beside .last

$t=&get_mydate;
&my_write("$tpath/monitor.log","monitor started $t\n");

&my_monitor;         # loop
exit;

#############        #opt, todo
sub my_stat {
#############
    # zpool iostat -vy 1 1  (1s intervall)  for io load
    #root@pve:~# zpool iostat -vy 1 1
    #              capacity     operations     bandwidth
    #pool        alloc   free   read  write   read  write
    #----------  -----  -----  -----  -----  -----  -----
    #tank        1.79G  1.96G      0      0      0      0
    #  sdb        926M   994M      0      0      0      0
    #  sdc        904M  1016M      0      0      0      0
    #----------  -----  -----  -----  -----  -----  -----

    # zpool status (bad pools, disks)

    # zpool list (cap, free health)
    # zpool list -H -o cap,health
    # PS C:\Users\me> zpool list
    # NAME   SIZE  ALLOC   FREE  CKPOINT  EXPANDSZ   FRAG    CAP  DEDUP    HEALTH  ALTROOT
    # tank  5.50G  1.25M  5.50G        -         -     0%     0%  1.00x    ONLINE  -

    # jobs (from local jobs.log)

    # top -n 1 (ausser win und Solaris)
    # top -n 1
    # top - 20:32:18 up 24 days,  1:58,  2 users,  load average: 0.07, 0.04, 0.00
    # Tasks: 207 total,   1 running, 206 sleeping,   0 stopped,   0 zombie
    # %Cpu(s): 50.0 us, 50.0 sy,  0.0 ni,  0.0 id,  0.0 wa,  0.0 hi,  0.0 si,  0.0 st
    # MiB Mem :   2964.4 total,   1331.1 free,   1279.1 used,    550.0 buff/cache
    # MiB Swap:   1024.0 total,   1024.0 free,      0.0 used.   1685.3 avail Mem

    # PID USER      PR  NI    VIRT    RES    SHR S  %CPU  %MEM     TIME+ COMMAND
    # 475933 root      20   0   11604   5376   3328 R  11.8   0.2   0:00.03 top
    # ..

    # load average: 0.07, 0.04, 0.00
    # 0.07: Die durchschnittliche CPU-Auslastung in der letzten Minute war 7%.
    # 0.04: Die durchschnittliche CPU-Auslastung in den letzten 5 Minuten war 4%.
    # 0.00: Die durchschnittliche CPU-Auslastung in den letzten 15 Minuten war 0%.


    # windows
    # wmic cpu get loadpercentage
}

sub my_add {           # add ("path/filename","data",);  max 50 lines
##############

    my $file = $_[0];
    my $data = $_[1];
    my @old;

    ##########################
    my $lock="$spath/tmp/log.lock";
    open (X,"<$lock");
      flock(X, LOCK_EX);
          #
          open (F,"<$file");                      # old file
                flock(F, LOCK_EX);
                @old=<F>;
          close (F);

          if (@old > 100) {                       # max 100 lines
                     $t=@old-100;
                     splice(@old,100,$t);
          }

         $t=join("",@old);
         open (PF, ">$file");
            flock(PF, LOCK_EX);
            print PF "$t\n$data";                 # programm must add \n if needed to allow added strings
         close (PF);

    close (X);                                    # close lock


    #########################

    return();
}

###############      # start, del all tmp files beside last
sub my_deltmp {
###############
       my @f  = glob("$tpath/*.*");
       foreach my $f (@f) {
          if ($f=~/\.last$|\.log$/) { next; }        # preserve log or last to auto refresh on start
          unlink($f);
       }
       $t=time();
       &my_write("$tpath/activity.log",$t);

}

#############
sub my_monitor {               # del all data files after 90s
#############                  # del all last files beside ; at the end (use for auto reload)
                               # 1729759640
                               # zpool list~      ~ is a marker for auto reload

                               # del all keys
                               # keep *.log
                               # activity.log (last activity), reload commands within 120s

  my (@p,@f,@r,$a,@l,$tm,$r,$p,$l,$df,$c,$up,$cmd);
  my $once="1";

  while (1) {

     $a  = &my_read("$tpath/activity.log");   chomp($a);  $a=~s/\D//gs;
     $tm = time();
     if (!($a >0))  { $a=$tm; &my_write("$tpath/activity.log","$a"); }
     $c=$tm-$a;


     if ($tm-$a > 240) { next; }              # 4 min activity window
     #print "monitor: activity $a, now $tm, diff $c\n";
     print "mon:$c ";

     @f  = glob("$tpath/*.*");

     # del old files and keys
     foreach my $f (@f)  {

          if ($f=~/\.completekey$/)  { print "unlink $f\n"; unlink($f); }

          # session.12345 (Windows gui only)
          #
          # S_AGENT|Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:131.0) Gecko/20100101 Firefox/131.0|
          # S_ID|whMkPFqpxK8oa8SY|
          # S_LID||
          # S_IP|127.0.0.1|
          # S_TIME|1729683637|
          # S_USER|admin|
          # S_VER||

          if ($f=~/\.session\d+/) {
               @r = &my_read("$f","a");

               $r[4]=~s/\D//g;                  # time

               if ($tm-$r[4] >36000) {           # 10h
                      print "unlink $f\n"; unlink($f);
               }
          }

          # .last and .data
          if ($f=~/\.last$/) {
             # 1729758483
             # zfs list
             # or zfs list~   (auto reload within activity period 4min)

             @l = &my_read("$f","a");           # last cmd

             if (($tm-$l[0] > 30) || ($once)) {              # 30s or once at startup
                 $once="0";
                 $df=$f;                        # datafile
                 $df=~s/\.last$/.data/;
                 if (-f $df) {
                      print "unlink $df\n"; unlink($df);  # all .data older 30s
                 }

                 # recache only last commands with ~ ex zpool list~
                 $cmd=$l[1];
                 $cmd=~s/~$//s;        # refresh marker
                 if (!($l[1]=~/~$/s)) {
                      $up="0";
                      print "mon, unlink $f\n"; unlink($f);  # .last cmd without ~
                      if (-f "$df") { unlink($df); }    # and data
                 }  else {
                     $up="1";
                 }

                 if  ($up) {           # 20s and update
                     chomp($l[1]);
                     $t=substr($df,-10);
                     if ($l[1]=~/Get\-/i) {
                         print "mon, reload: powershell -command \"$cmd\" > ..$t\n";
                         $c=`powershell -command \"$cmd\"`;      # re cache ps cmd
                     } else {
                         print "mon, reload: $cmd > ..$t\n";
                         $c=`$cmd`;                 # re cache cmd
                     }
                     &my_write("$df",$c);

                     # update .last
                     $l[0]=time();
                     $c=join("\n",@l);
                     &my_write("$f",$c);

                 }

                 if ($f=~/\.req_htm$/)    { print "mon, unlink $f\n"; unlink($f); }  # html request
             }
          }
     }
     sleep(20);
  }
}

sub my_write {                 #   write ("path/filename","data",);
##############
    my $file = $_[0];
    my $data = $_[1];

    open(my $fh,">$file");
      flock($fh, LOCK_EX);
        print $fh "$data\n";
      flock($fh, LOCK_UN);
    close($fh);

    return();
}

sub my_read {           # read   read("path/filename");
##############
    my $file = $_[0];
    my $type = $_[1];     # opt: a -> return array

    my $data="";
    my @data=();

    if (-f $file) {
        #
        open(my $fh, "<$file");
          flock($fh, LOCK_EX);
             @data = <$fh>;
          flock($fh, LOCK_UN);
        close($fh);
        $data=join("",@data);

        if ($type=~/a/) {  return (@data); }

    } else {
         $data="$file not found";

    }
    return($data);
}


sub get_mydate {                # setzt datumsvariablen
###########
 my ($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime(time);
 $mon++;
 if ($sec < 10) { $sec = "0$sec"; }
 if ($min < 10) { $min = "0$min"; }
 if ($hour < 10) { $hour = "0$hour"; }
 if ($mday < 10) { $mday = "0$mday"; }
 if ($mon < 10) { $mon = "0$mon"; }
 $year=1900+$year;
 return("$year\.$mon\.$mday\.$hour\.$min\.$sec");
}


#1;
